#include "main.h"
#include "timebase.h"
#include "schedule.h"


void led0_off( void )
{
  PORTB |= 1<<PB0;		// LED off
}


void led0_on( void )
{
  PORTB &= ~(1<<PB0);         	// LED on
  timeradd( led0_on, 500 );     // insert itself (period time)
  timeradd( led0_off, 200 );    // insert switching off (off time)
}


void led1_off( void )
{
  PORTB |= 1<<PB1;
}


void led1_on( void )
{
  PORTB &= ~(1<<PB1);
  timeradd( led1_on, 510 );
  timeradd( led1_off, 200 );
}


void led2_off( void )
{
  PORTB |= 1<<PB2;
}


void led2_on( void )
{
  PORTB &= ~(1<<PB2);
  timeradd( led2_on, 520 );
  timeradd( led2_off, 200 );
}


void led3_off( void )
{
  PORTB |= 1<<PB3;
}


void led3_on( void )
{
  PORTB &= ~(1<<PB3);
  timeradd( led3_on, 530 );
  timeradd( led3_off, 200 );
}


void led4_off( void )
{
  PORTB |= 1<<PB4;
}


void led4_on( void )
{
  PORTB &= ~(1<<PB4);
  timeradd( led4_on, 540 );
  timeradd( led4_off, 200 );
}


void led5_off( void )
{
  PORTB |= 1<<PB5;
}


void led5_on( void )
{
  PORTB &= ~(1<<PB5);
  timeradd( led5_on, 550 );
  timeradd( led5_off, 200 );
}


void led6_off( void )
{
  PORTB |= 1<<PB6;
}


void led6_on( void )
{
  PORTB &= ~(1<<PB6);
  timeradd( led6_on, 560 );
  timeradd( led6_off, 200 );
}


void led7_off( void )
{
  PORTB |= 1<<PB7;
}


void led7_on( void )
{
  PORTB &= ~(1<<PB7);
  timeradd( led7_on, 570 );
  timeradd( led7_off, 200 );
}


int main( void )
{
  DDRB = 0xFF;
  PORTA = 0xFF;
  PORTB = 0xFF;
  timebaseinit();			// timer interrupt
  timerinit();				// scheduler
  sei();
  led0_on();
  led1_on();
  led2_on();
  led3_on();
  led4_on();
  led5_on();
  led6_on();
  led7_on();

  for(;;){
    if( f_time_tick ){
      f_time_tick = 0;
      timertick();
    }
  }
}
