typedef void (code *funcp)(void);

//#define t_res		u8		// define time resolution  8 bit
#define t_res		u16		// define time resolution 16 bit

#define t_data		idata		// timer data segment

#define MAXTIMERS	 18
#define T_FREE		254		// > MAXTIMERS
#define T_LAST		255

typedef struct{
  u8 next;				// next in list or end mark
  t_res delta;				// delta to previous entry
  funcp func;				// function to serve
} t_ctrl_struct;


void timertick(void);
bit timeradd( funcp func, t_res delay );
bit timerremove( funcp func );
void timerinit(void);
